<script lang="ts">
	import { fade } from 'svelte/transition';
	import { isVisitor, updateWalletStore } from '../../stores/stores';
	import Input from './Input.svelte';
	import Button from './Button.svelte';
	import Select from './Select.svelte';
	import { onMount } from 'svelte';
	import { getCustomerById, updateWallet } from '../../routes/api/customer/customer';
	import { ISO2Currencies, type ISO2Currency } from '../../routes/api/customer/types';

	export let showModal = false;
	let money = 0;

	function closeModal() {
		showModal = false;
	}

	const changeAmount: Map<string, number> = new Map([
		['EUR', 1],
		['USD', 1.08],
		['GBP', 1.17],
		['JPY', 156],
		['CHF', 1.06]
	]);
	let amountMulti = 0;
	let amountEuro = 0;

	let customerID = '';
	onMount(() => {
		customerID = sessionStorage.getItem('customerID');
	});

	const calculateEuroAmount = () => {
		amountEuro = amountMulti * changeAmount.get(selectCurrency);
	};

	const calculateMultiAmount = () => {
		amountMulti = amountEuro / changeAmount.get(selectCurrency);
	};

	let loading: boolean = false;
	const handleMoney = () => {
		loading = true;
		updateWallet(customerID, { balance: amountEuro, currency: 'EUR' }).then(() => {
			// getCustomerById(customerID).then((v) => (userBalance = v?.customer?.wallet.balance ?? 0));
			updateBalance();
			setTimeout(() => {
				loading = false;
				closeModal();
				location.reload();
			}, 1000);
		});
	};

	let userBalance = 0;
	$: if (!$isVisitor && customerID) {
		updateBalance();
	}

	const updateBalance = () => {
		getCustomerById(customerID).then((v) => (userBalance = v?.customer?.wallet.balance ?? 0));
	};

	let selectCurrency: ISO2Currency = 'EUR';
</script>

{#if showModal}
	<div
		class="modal fixed inset-0 flex items-center justify-center bg-dark-surface-500 bg-opacity-40 z-10"
		transition:fade
	>
		<div
			class="modal-content bg-light-surface-500 p-8 rounded-lg shadow-lg w-80 flex flex-col gap-4"
		>
			<h2 class="text-2xl font-bold mb-4">Vous avez {userBalance}€</h2>

			<span>Veuillez sélectionner un montant :</span>
			<div class="flex gap-2 items-center">
				<Input
					label="Montant"
					bind:value={amountMulti}
					type="number"
					on:input={calculateEuroAmount}
				/>
				<span>en</span>
				<Select
					items={Object.values(ISO2Currencies).filter((v) => isNaN(Number(v)))}
					bind:selected={selectCurrency}
				/>
			</div>
			<div class="h-1 border-b border-black w-full" />
			<Input
				label="Montant en €"
				bind:value={amountEuro}
				type="number"
				on:input={calculateMultiAmount}
			/>
			<div class="flex gap-2 w-full justify-between items-center">
				<Button on:click={closeModal} type="secondary" {loading}>Retour</Button>
				<Button on:click={handleMoney} {loading}>Ajouter</Button>
			</div>
		</div>
	</div>
{/if}
